 /*
*	Added by Ryan Rife
*/
declare @exists int
exec @exists = sb_check_cs_log 'AddMutliSiteSupport'
if(@exists = 0)
begin	
	IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_sites]') AND type in (N'U'))
	BEGIN 
		BEGIN TRANSACTION
		CREATE TABLE dbo.sb_sites
		(
		SiteID int NOT NULL IDENTITY (1, 1),
		SiteName varchar(50) NOT NULL,
		SiteURL nchar(255) NOT NULL
		)  ON [PRIMARY]
		
		ALTER TABLE dbo.sb_sites ADD CONSTRAINT
		PK_sb_sites PRIMARY KEY CLUSTERED 
		(
		SiteID
		) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

		COMMIT	

		ALTER TABLE dbo.sb_links ADD SiteID INT
		ALTER TABLE dbo.sb_links ADD CONSTRAINT
			FK_sb_links_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 
			 
		ALTER TABLE dbo.sb_attachments ADD SiteID INT
		ALTER TABLE dbo.sb_attachments ADD CONSTRAINT
			FK_sb_attachments_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
		
		ALTER TABLE dbo.sb_categories ADD SiteID INT
		ALTER TABLE dbo.sb_categories ADD CONSTRAINT
			FK_sb_categories_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 		

		ALTER TABLE dbo.sb_comments ADD SiteID INT
		ALTER TABLE dbo.sb_comments ADD CONSTRAINT
			FK_sb_comments_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 

		ALTER TABLE dbo.sb_downloads ADD SiteID INT
		ALTER TABLE dbo.sb_downloads ADD CONSTRAINT
			FK_sb_downloads_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_galleries ADD SiteID INT
		ALTER TABLE dbo.sb_galleries ADD CONSTRAINT
			FK_sb_galleries_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_galleryimages ADD SiteID INT
		ALTER TABLE dbo.sb_galleryimages ADD CONSTRAINT
			FK_sb_galleryimages_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_postcategories ADD SiteID INT
		ALTER TABLE dbo.sb_postcategories ADD CONSTRAINT
			FK_sb_postcategories_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 

		ALTER TABLE dbo.sb_posts ADD SiteID INT
		ALTER TABLE dbo.sb_posts ADD CONSTRAINT
			FK_sb_posts_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 

		ALTER TABLE dbo.sb_roles ADD SiteID INT
		ALTER TABLE dbo.sb_roles ADD CONSTRAINT
			FK_sb_roles_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_settings ADD SiteID INT
		ALTER TABLE dbo.sb_settings ADD CONSTRAINT
			FK_sb_settings_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_userroles ADD SiteID INT
		ALTER TABLE dbo.sb_userroles ADD CONSTRAINT
			FK_sb_userroles_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_users ADD SiteID INT
		ALTER TABLE dbo.sb_users ADD CONSTRAINT
			FK_sb_users_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
			 
		ALTER TABLE dbo.sb_users_ext ADD SiteID INT
		ALTER TABLE dbo.sb_users_ext ADD CONSTRAINT
			FK_sb_users_ext_sb_sites FOREIGN KEY
			(
			SiteID
			) REFERENCES dbo.sb_sites
			(
			SiteID
			) ON UPDATE  NO ACTION 
			 ON DELETE  NO ACTION 			 
	END
	exec sb_log_cs 'AddMutliSiteSupport'
end		