/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyPostCount]    Script Date: 08/14/2006 17:33:11 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetMonthlyPostCount]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sb_GetMonthlyPostCount]
GO
/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyPostCount]    Script Date: 08/14/2006 17:33:11 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetMonthlyPostCount]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE dbo.sb_GetMonthlyPostCount
AS
Declare @Month int
Declare @Year int
Declare @PostCount int
CREATE TABLE #MonthQuery ([Month] int, [Year] int, PostCount int)

Declare date_cursor Cursor For 
Select Distinct Month(EntryDate), Year(EntryDate) From sb_posts
Open date_cursor

Fetch Next From date_cursor 
Into @Month, @Year

While @@FETCH_STATUS = 0
Begin
	Select @PostCount = Count(*) From sb_posts Where Month(EntryDate) = @Month And Year(EntryDate) = @Year
	Insert Into #MonthQuery ([Month], [Year], PostCount) Values (@Month, @Year, @PostCount)
	Fetch Next From date_cursor 
	Into @Month, @Year
End

Close date_cursor
Deallocate date_cursor

Select * From #MonthQuery' 
END
GO
/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyTeasers]    Script Date: 08/14/2006 18:27:59 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetMonthlyTeasers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sb_GetMonthlyTeasers]
GO
/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyTeasers]    Script Date: 08/14/2006 18:27:59 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetMonthlyTeasers]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE dbo.sb_GetMonthlyTeasers 
	(
	@Month int,
	@Year int
	)
AS
	SELECT dbo.sb_users.AuthorName, dbo.sb_posts.*, (Select Count(*) From sb_comments Where sb_comments.PostID = sb_posts.PostID and ConfirmGUID is null) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID Where Month(EntryDate) = @Month and Year(EntryDate) = @Year	order by EntryDate desc
	RETURN
' 
END
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPostTeasers]    Script Date: 08/14/2006 16:22:40 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetPostTeasers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sb_GetPostTeasers]
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPostTeasers]    Script Date: 08/14/2006 16:22:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_GetPostTeasers]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE dbo.sb_GetPostTeasers 	
AS
	SELECT top 15    dbo.sb_users.AuthorName, dbo.sb_posts.*, (Select Count(*) From sb_comments Where sb_comments.PostID = sb_posts.PostID and ConfirmGUID is null) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID	order by EntryDate desc
	RETURN
' 
END
GO
/****** Object:  StoredProcedure [dbo].[sb_SavePost]    Script Date: 08/14/2006 16:33:33 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_SavePost]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sb_SavePost]
GO
/****** Object:  StoredProcedure [dbo].[sb_SavePost]    Script Date: 08/14/2006 16:33:33 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_SavePost]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE dbo.sb_SavePost 
	(
		@PostID Int Output,
		@AuthorID Int,
		@Title VarChar(50),
		@Preview VarChar(500),
		@Body VarChar(5000),
		@ReferenceURL VarChar(1024),
		@ReferenceTitle VarChar(50),
		@FileName VarChar(50) = null,
		@FileDescription VarChar(300) = null,
		@FileFileName VarChar(255) = null,
		@FileData Image = null,
		@FileSize decimal = null,
		@FileContentType VarChar(255) = null,
		@RemoveFile bit
	)
AS

IF(@PostID = -1)
BEGIN
	Insert Into sb_posts (Title, EntryDate, AuthorID) Values (@Title, GetDate(), @AuthorID)
	Select @PostID = Scope_Identity()
END


IF(@PostID > 0)
BEGIN
	Delete From sb_postcategories Where PostID = @PostID
	
	Update sb_posts Set Title = @Title, Body = @Body, PreviewText = @Preview, ReferenceURl = @ReferenceURL, ReferenceURLTitle = @ReferenceTitle Where PostID = @PostID
	
	
	IF(@FileName Is Not Null)
	BEGIN
		Declare @FileID Int
		Select @FileID = FileAttachmentID From sb_posts Where PostID = @PostID
		
		IF(@FileID Is Not Null or @FileData Is Not Null)
		Begin
			IF(@FileID IS Null or @FileID < 1)
			BEGIN
				Insert Into sb_attachments ([Name], Description) Values (@FileName, @FileDescription)
				Select @FileID = Scope_Identity()
			END
			
			IF(@FileData Is Null)
				Update sb_attachments Set [Name] = @FileName, Description = @FileDescription Where FileID = @FileID
			Else
				Update sb_attachments Set [Name] = @FileName, Description = @FileDescription, FileName = @FileFileName,
					Data = @FileData, [Size] = @FileSize, ContentType = @FileContentType, EntryDate = GetDate() Where FileID = @FileID		
		END
		
		Update sb_posts Set FileAttachmentID = @FileID Where PostID = @PostID
	END
	
	IF(@RemoveFile = 1)
	BEGIN
		Delete From sb_attachments Where FileID = (Select FileAttachmentID From sb_posts Where PostID = @PostID)
	END
END

Select @PostID' 
END
GO
/****** Object:  StoredProcedure [dbo].[sb_SetupUser]    Script Date: 08/12/2006 21:45:27 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_SetupUser]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[sb_SetupUser]
GO
/****** Object:  StoredProcedure [dbo].[sb_SetupUser]    Script Date: 08/12/2006 21:45:27 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sb_SetupUser]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE dbo.sb_SetupUser 
	(
	@Username varchar(50),
	@Password varchar(255)
	)
AS
	
	Insert Into sb_users (Username, Password, AuthorName) Values (@Username, @Password, @Username)
	Select Scope_Identity()' 
END
GO
 