 USE [SimpleBlog]
GO
/****** Object:  StoredProcedure [dbo].[sb_DeletePost]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_DeletePost] 
	(
	@SiteID int = null, 
	@PostID Int
	)
AS
Delete From sb_comments Where PostID = @PostID
Delete From sb_postcategories Where PostID = @PostID

Declare @FileID Int
Select @FileID = FileAttachmentID From sb_posts Where PostID = @PostID

Delete From sb_downloads Where FileID = @FileID
Delete From sb_posts Where PostID = @PostID
Delete From sb_attachments Where FileID = @FileID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SavePostCategory]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SavePostCategory] 
	(
	@SiteID int = null, 
	@PostID int,
	@CategoryID int
	)
AS
Insert Into sb_postcategories (PostID, CategoryID, SiteID) Values (@PostID, @CategoryID, @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetCategoryTeasers]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetCategoryTeasers] 
	(
	@SiteID int = null, 
	@Category varchar(50)
	)
AS
SELECT     dbo.sb_users.AuthorName, dbo.sb_posts.*,
                          (SELECT     Count(*)
                            FROM          sb_comments
                            WHERE      sb_comments.PostID = sb_posts.PostID AND ConfirmGUID IS NULL) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_postcategories ON dbo.sb_posts.PostID = dbo.sb_postcategories.PostID INNER JOIN
                      dbo.sb_categories ON dbo.sb_postcategories.CategoryID = dbo.sb_categories.CategoryID INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID
WHERE     sb_posts.Publish = 1 AND sb_categories.category = @Category And (sb_posts.SiteID Is Null Or sb_posts.SiteID = @SiteID)
ORDER BY EntryDate DESC
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPost]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetPost] 
	(
	@SiteID int, 
	@PostID int
	)
AS
SELECT     dbo.sb_users.AuthorName, dbo.sb_posts.PostID, dbo.sb_posts.Publish, dbo.sb_posts.GalleryID, dbo.sb_posts.Details, dbo.sb_posts.Comments, dbo.sb_posts.AuthorID, dbo.sb_posts.Title, dbo.sb_posts.Body, dbo.sb_posts.EntryDate, 
                      dbo.sb_posts.PreviewText, dbo.sb_posts.ReferenceURL, dbo.sb_posts.ReferenceURLTitle, dbo.sb_posts.FileAttachmentID, dbo.sb_posts.ShowTeaser, dbo.sb_posts.Pinned,
                          (SELECT     COUNT(*) AS Expr1
                            FROM          dbo.sb_comments
                            WHERE      (PostID = dbo.sb_posts.PostID) And ConfirmGUID is Null) AS CommentCount, dbo.sb_attachments.Name AS FileName, 
                      dbo.sb_attachments.Description AS FileDescription
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID LEFT OUTER JOIN
                      dbo.sb_attachments ON dbo.sb_posts.FileAttachmentID = dbo.sb_attachments.FileID Where PostID = @PostID

SELECT   distinct(dbo.sb_categories.Category)
FROM         dbo.sb_postcategories INNER JOIN
                      dbo.sb_categories ON dbo.sb_postcategories.CategoryID = dbo.sb_categories.CategoryID Where PostID = @PostID

Select * From sb_comments Where PostID = @PostID and ConfirmGUID Is Null Order By EntryDate

Update sb_posts Set ViewCount = (isnull(ViewCount, 0) + 1) Where PostID = @PostID

	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetSetting]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetSetting] 
	(
	@SiteID int = null, 
	@SettingName varchar(30),
	@DefaultValue varchar(1024)= null,
	@SaveValue bit = 1
	)
AS
Declare @Value varchar(1024)
Select @Value = [Value] From sb_settings Where [Name] = @SettingName And (SiteID Is NULL or SiteID = @SiteID)
IF(@Value Is Null and @DefaultValue is not null)
BEGIN
	Delete From sb_settings Where [Name] = @SettingName And SiteID = @SiteID
	if(@SaveValue = 1)
		Insert Into sb_settings ([Name], [Value], SiteID) Values (@SettingName, @DefaultValue, @SiteID)
	Select @Value = @DefaultValue
END
Select @Value
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveSetting]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveSetting] 
	(
	@SiteID int = null, 
	@SettingName varchar(30),
	@SettingValue varchar(1024)
	)
AS
Delete From sb_settings Where [Name] = @SettingName And SiteID = @SiteID

Insert Into sb_settings ([Name], [Value], SiteID) Values (@SettingName, @SettingValue, @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetSettings]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetSettings] 
(
@SiteID int = null
)
AS
Select * From sb_settings Where (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_AuthUser]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_AuthUser] 
	(
	@SiteID int = null, 
	@Username varchar(50),
	@Password varchar(255)
	)
AS
	
	Select * From sb_users Where Username = @Username And Password = @Password And ConfirmGUID Is Null And (Enabled = 1 or Enabled Is Null) And (SiteID Is Null Or SiteID = @SiteID)
	
	Select sb_roles.RoleName, sb_userroles.UserID From sb_userroles 
		Inner Join sb_roles On sb_userroles.RoleID = sb_roles.RoleID 
		Inner Join sb_users On sb_userroles.UserID = sb_users.UserID
		Where Username = @Username And Password = @Password And (sb_roles.SiteID Is Null Or sb_roles.SiteID = @SiteID)
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveUserRole]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveUserRole] 	
	(
	@SiteID int = null, 
	@UserID Int,
	@RoleName VarChar(50) = null,
	@RoleID Int = null
	)	
AS
	IF(@RoleName Is Not Null Or @RoleID Is Not Null)
	BEGIN
		IF(@RoleID Is Null)
		BEGIN
			Select @RoleID = RoleID From sb_roles Where RoleName = @RoleName And SiteID = @SiteID
		END
		
		IF(@RoleID Is Not Null)
		BEGIN
			Delete From sb_userroles Where UserID = @UserID And RoleID = @RoleID
			Insert Into sb_userroles (UserID, RoleID, SiteID) Values (@UserID, @RoleID, @SiteID)
		END
	END
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetUser]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetUser] 
(
	@SiteID int = null, 
	@UserID Int
)
AS
Select * From sb_users Where UserID = @UserID

Select sb_userroles.UserID, sb_roles.RoleID, sb_roles.RoleName
From sb_userroles Inner Join sb_roles ON sb_userroles.RoleID = sb_roles.RoleID
Where UserID = @UserID

Select UserID, [Name], Null From sb_users_ext sbe Where UserID = @UserID 
UNION 
Select Distinct @UserID As UserID, [Name], Null As [Value] From sb_users_ext 
	Where [Name] Not In (Select Distinct [Name] From sb_users_ext Where UserID = @UserID)
	
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPostTitles]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetPostTitles] 
(
@SiteID int = null
)
AS
	Select PostID, Title From sb_posts where (SiteID Is Null Or SiteID = @SiteID) Order By Title
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPosts]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetPosts] 
(
@SiteID int = null
)
AS
	Select sb_posts.*, (Select Count(CommentID) From sb_comments Where sb_comments.PostID = sb_posts.PostID  And (SiteID Is Null Or SiteID = @SiteID)) As CommentCount
		From sb_posts Where (SiteID Is Null Or SiteID = @SiteID) Order By EntryDate Desc
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetPostTeasers]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetPostTeasers] 	
(
@SiteID int = null
)
AS
	SELECT top 15 dbo.sb_users.AuthorName, dbo.sb_posts.*, (Select Count(*) From sb_comments Where sb_comments.PostID = sb_posts.PostID and ConfirmGUID is null) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID And sb_posts.Publish = 1  And (sb_posts.SiteID Is Null Or sb_posts.SiteID = @SiteID) order by Pinned desc, EntryDate desc
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetAllTeasers]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetAllTeasers] 
(
@SiteID int = null
)
AS
SELECT     dbo.sb_users.AuthorName, dbo.sb_posts.*,
                          (SELECT     Count(*)
                            FROM          sb_comments
                            WHERE      sb_comments.PostID = sb_posts.PostID AND ConfirmGUID IS NULL) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID
WHERE     sb_posts.Publish = 1 And (sb_posts.SiteID Is Null Or sb_posts.SiteID = @SiteID)
ORDER BY EntryDate DESC
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetAttachments]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetAttachments] 
(
@SiteID int = null
)
AS
SELECT     dbo.sb_attachments.FileID, dbo.sb_attachments.Name, dbo.sb_attachments.Description, dbo.sb_attachments.FileName, 
                      dbo.sb_attachments.Size, dbo.sb_attachments.ContentType, dbo.sb_attachments.EntryDate, dbo.sb_attachments.DownloadCount, 
                      dbo.sb_posts.PostID, dbo.sb_posts.Title, dbo.sb_downloads.FileID AS DownloadID
FROM         dbo.sb_attachments LEFT OUTER JOIN
                      dbo.sb_downloads ON dbo.sb_attachments.FileID = dbo.sb_downloads.FileID LEFT OUTER JOIN
                      dbo.sb_posts ON dbo.sb_attachments.FileID = dbo.sb_posts.FileAttachmentID Where (sb_attachments.SiteID Is Null Or sb_attachments.SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyPostCount]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetMonthlyPostCount]
(
@SiteID int = null
)
AS
Declare @Month int
Declare @Year int
Declare @PostCount int
CREATE TABLE #MonthQuery ([Month] int, [Year] int, PostCount int)

Declare date_cursor Cursor For 
Select Distinct Month(EntryDate), Year(EntryDate) From sb_posts Where Publish = 1  And (SiteID Is Null Or SiteID = @SiteID) Order By Year(EntryDate) Desc, Month(EntryDate) Desc
Open date_cursor

Fetch Next From date_cursor 
Into @Month, @Year

While @@FETCH_STATUS = 0
Begin
	Select @PostCount = Count(*) From sb_posts Where Month(EntryDate) = @Month And Year(EntryDate) = @Year And Publish = 1  And (SiteID Is Null Or SiteID = @SiteID)
	Insert Into #MonthQuery ([Month], [Year], PostCount) Values (@Month, @Year, @PostCount)
	Fetch Next From date_cursor 
	Into @Month, @Year
End

Close date_cursor
Deallocate date_cursor

Select * From #MonthQuery
GO
/****** Object:  StoredProcedure [dbo].[sb_GetMonthlyTeasers]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetMonthlyTeasers] 
	(
	@SiteID int = null, 
	@Month int,
	@Year int
	)
AS
	SELECT dbo.sb_users.AuthorName, dbo.sb_posts.*, (Select Count(*) From sb_comments Where sb_comments.PostID = sb_posts.PostID and ConfirmGUID is null) CommentCount
FROM         dbo.sb_posts INNER JOIN
                      dbo.sb_users ON dbo.sb_posts.AuthorID = dbo.sb_users.UserID Where Month(EntryDate) = @Month and Year(EntryDate) = @Year And Publish = 1  And (sb_posts.SiteID Is Null Or sb_posts.SiteID = @SiteID) order by EntryDate desc
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetComments]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetComments] 
	(
	@SiteID int = null, 
	@PostID int = null
	)
AS
IF(@PostID Is Null)
BEGIN
	Select * From sb_comments
END
ELSE
BEGIN
	Select * From sb_comments Where PostID = @PostID
END
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_ConfirmComment]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_ConfirmComment] 
	(
	@SiteID int = null, 
	@CommentID Int = Null,
	@ConfirmGUID char(32) = null
	)
AS
IF(@CommentID Is Not Null)
BEGIN
	Update sb_comments Set ConfirmGUID = Null Where CommentID = @CommentID
END

IF(@ConfirmGUID Is Not Null)
BEGIN
	Update sb_comments Set ConfirmGUID = Null Where ConfirmGUID = @ConfirmGUID
END
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_DeleteComment]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_DeleteComment]
	(
	@SiteID int = null, 
	@CommentID Int
	)
AS
Delete From sb_comments Where CommentID = @CommentID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveComment]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveComment] 	
	(
	@SiteID int = null, 
	@PostID int,
	@AuthorName varchar(50),
	@AuthorEmail varchar(500),
	@AuthorURL varchar(500),
	@Comment varchar(500),
	@ConfirmGUID char(32),
	@ClientIP varchar(50)
	)	
AS
Insert Into sb_comments (PostID, AuthorName, AuthorURL, AuthorEmail, ConfirmGUID, EntryText, EntryDate, ClientIP, SiteID)
Values	(@PostID, @AuthorName, @AuthorURL, @AuthorEmail, @ConfirmGUID, @Comment, GetDate(), @ClientIP, @SiteID)	
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetSiteID]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetSiteID] 	
	(
	@SiteID	int = -1 OUTPUT,
	@SiteName varchar(50),
	@SiteURL varchar(255)
	)
AS
	SELECT @SiteID = SiteID FROM sb_sites WHERE
		SiteName = @SiteName AND
		SiteURL = @SiteURL
		
	IF(@SiteID Is NULL OR @SiteID <= 0)
	BEGIN
	
		INSERT INTO sb_sites (SiteName, SiteURL) Values
			(@SiteName, @SiteURL)
		
		SET @SiteID = Scope_Identity()		
	END
	
	SELECT @SiteID
		
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetFile]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetFile]	
	(
	@SiteID int = null, 
	@FileID Int
	)
AS
Select * From sb_attachments Where FileID = @FileID

Update sb_attachments Set DownloadCount = (isnull(DownloadCount, 0) + 1) Where FileID = @FileID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_DeleteAttachment]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_DeleteAttachment] 
	(
	@SiteID int = null, 
	@FileID int
	)
AS
Delete From sb_downloads Where FileID = @FileID
Delete From sb_attachments Where FileID = @FileID
Delete From sb_galleryimages Where FileID = @FileID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetDownloads]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetDownloads] 
(
@SiteID int = null
)
AS
SELECT     dbo.sb_attachments.FileID, dbo.sb_attachments.Name, dbo.sb_attachments.Description, dbo.sb_attachments.FileName, 
                      dbo.sb_attachments.Size, dbo.sb_attachments.ContentType, dbo.sb_attachments.EntryDate, dbo.sb_attachments.DownloadCount
FROM         dbo.sb_downloads LEFT OUTER JOIN
                      dbo.sb_attachments ON dbo.sb_downloads.FileID = dbo.sb_attachments.FileID Where (sb_downloads.SiteID Is Null Or sb_downloads.SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetGalleryThumbnail]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetGalleryThumbnail]	
	(
	@SiteID int = null, 
	@FileID Int
	)
AS
	Select sb_attachments.FileID, sb_attachments.Name, sb_attachments.Description, sb_attachments.FileName, 
		sb_attachments.ContentType, sb_attachments.EntryDate, sb_attachments.DownloadCount, sb_galleryimages.ThumbData As [Data], 
		sb_galleryimages.ThumbSize As [Size], sb_galleryimages.GalleryID
	From sb_attachments Inner Join
		sb_galleryimages ON sb_attachments.FileID = sb_galleryimages.FileID
	Where sb_galleryimages.FileID = @FileID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveAttachment]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveAttachment] 
	(
		@SiteID int = null, 
		@FileID Int = null Output,
		@FileName VarChar(50),
		@FileDescription VarChar(300) = null,
		@FileFileName VarChar(255) = null,
		@FileData Image = null,
		@FileSize decimal = null,
		@FileContentType VarChar(255) = null,
		@Folder VarChar(50) = null
	)
AS
	IF(@FileID IS Null or @FileID < 1)
	BEGIN
		Insert Into sb_attachments ([Name], Folder, EntryDate, SiteID) Values (@FileName, @Folder, GetDate(), @SiteID)
		Select @FileID = Scope_Identity()
	END
	
	Update sb_attachments Set [Name] = @FileName, Description = @FileDescription, Folder = @Folder Where FileID = @FileID
	
	IF(@FileFileName Is Not Null)
	Begin
		Update sb_attachments Set FileName = @FileFileName,
			Data = @FileData, [Size] = @FileSize, ContentType = @FileContentType Where FileID = @FileID		
	End				
Return @FileID
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveGalleryImage]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveGalleryImage]
	(
		@SiteID int = null, 
		@FileID Int = null,
		@FileName VarChar(50),
		@FileDescription VarChar(300) = null,
		@FileFileName VarChar(255) = null,
		@FileData Image = null,
		@FileSize decimal = null,
		@FileContentType VarChar(255) = null,
		@GalleryID int,
		@ThumbData Image = null,
		@ThumbSize decimal = null
	)
AS
	IF(@FileID IS Null or @FileID < 1)
	BEGIN
		Insert Into sb_attachments ([Name], Folder, EntryDate, SiteID) Values (@FileName, 'Gallery', GetDate(), @SiteID)
		Select @FileID = Scope_Identity()
	END
	
	Update sb_attachments Set [Name] = @FileName, Description = @FileDescription, Folder = 'Gallery' Where FileID = @FileID
	
	IF(@FileFileName Is Not Null)
	Begin
		Update sb_attachments Set FileName = @FileFileName,
			Data = @FileData, [Size] = @FileSize, ContentType = @FileContentType Where FileID = @FileID		
		
		Delete From sb_galleryimages Where FileID = @FileID
		Insert Into sb_galleryimages (FileID, ThumbData, ThumbSize, GalleryID, SiteID) Values
			(@FileID, @ThumbData, @ThumbSize, @GalleryID, @SiteID)
	End				
Return
GO
/****** Object:  StoredProcedure [dbo].[sb_PublishAttachment]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_PublishAttachment]
	(
	@SiteID int = null, 
	@FileID Int
	)
AS
Insert Into sb_downloads (FileID) Values (@FileID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_UnpublishAttachment]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_UnpublishAttachment]
	(
	@SiteID int = null, 
	@FileID Int
	)
AS
Delete From sb_downloads Where FileID = @FileID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetCategories]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetCategories] 
(
@SiteID int = null
)
AS
Select * From sb_categories Where (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetCategory]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetCategory] 
	(
	@SiteID int = null, 
	@CategoryID int
	)
AS
Select * From sb_categories Where CategoryID = @CategoryID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveCategory]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveCategory] 
	(
	@SiteID int = null, 
	@CategoryID	int = -1,
	@Category	varchar(50)
	)
AS
IF(@CategoryID = -1)
BEGIN
	Insert Into sb_categories (Category, SiteID) Values (@Category, @SiteID)
	Select @CategoryID = Scope_Identity()
END

Update sb_categories Set Category = @Category Where CategoryID = @CategoryID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_log_cs]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
Create PROCEDURE [dbo].[sb_log_cs]
		(
		@Script VarChar(255)
		)
	AS
	Insert Into sb_cs_log (ChangeDate, Script) Values (GetDate(), @Script)
		RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_check_cs_log]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_check_cs_log]
		(
		@Script VarChar(255)
		)
	AS
	IF NOT EXISTS (Select * From sb_cs_log Where Script = @Script)
		Return 0
	ELSE
		Return  1
GO
/****** Object:  StoredProcedure [dbo].[sb_GetRole]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetRole]
	(@SiteID int = null, 
	@RoleID Int)
AS
	Select * From sb_roles Where RoleID = @RoleID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetRoles]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetRoles] 
(
@SiteID int = null
)
AS
	Select * From sb_roles  Where (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveRole]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveRole] 
	(
	@SiteID int = null, 
	@RoleID	int = -1,
	@RoleName	varchar(50)
	)
AS
IF(@RoleID = -1)
BEGIN
	Insert Into sb_roles (RoleName, SiteID) Values (@RoleName, @SiteID)
	Select @RoleID = Scope_Identity()
END

Update sb_roles Set RoleName = @RoleName Where RoleID = @RoleID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveUser]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveUser] 
	(
	@SiteID int = null, 
	@UserId Int = Null OUTPUT,
	@Username varchar(50),
	@Password varchar(255) = null,
	@OldPassword varchar(255) = null,
	@AuthorName varchar(50) = Null,
	@AuthorURL varchar(500) = Null,	
	@ConfirmGUID char(32) = Null,
	@AuthorEmail varchar(500) = Null,
	@Enabled bit = Null
	)
AS
	If(@UserId Is Null)
	Begin
		Insert Into sb_users (Username, Password, AuthorName, Enabled, SiteID) Values (@Username, @Password, @AuthorName, @Enabled, @SiteID)	
		Set @UserId = Scope_Identity()
	End
	
	Update sb_users Set ConfirmGUID = @ConfirmGUID
	
	if(@Enabled Is Not Null)
		Update sb_users Set Enabled = @Enabled
	
	if(@AuthorEmail Is Not Null)
		Update sb_users Set AuthorEmail = @AuthorEmail Where UserID = @UserID
	

	if(@Password Is Not Null and @OldPassword Is Null)
		Update sb_users Set Password = @Password Where UserID = @UserID
	
	if(@Password Is Not Null and @OldPassword Is Not Null)
		Update sb_users Set Password = @Password Where UserID = @UserID and Password = @OldPassword
		
	
	if(@AuthorURL Is Not Null)
		Update sb_users Set AuthorURL = @AuthorURL Where UserID = @UserID
		
	
	if(@AuthorName Is Not Null)
		Update sb_users Set AuthorName = @AuthorName Where UserID = @UserID
	else
		Update sb_users Set AuthorName = @Username Where UserID = @UserID
		
	Select @UserID
GO
/****** Object:  StoredProcedure [dbo].[sb_GetUsers]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetUsers] 
(
@SiteID int = null
)
AS
Select * From sb_users Where (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_CheckUser]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_CheckUser] 
	(
	@SiteID int = null, 
	@Username varchar(50),
	@AuthorEmail varchar(500)
	)
AS
	Select Count(*) From sb_users Where Username = @Username Or AuthorEmail = @AuthorEmail And (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_ConfirmUser]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_ConfirmUser]
	(
	@SiteID int = null, 
	@UserID Int = Null,
	@ConfirmGUID char(32) = null
	)
AS
IF(@UserID Is Not Null)
BEGIN
	Update sb_users Set ConfirmGUID = Null Where UserID = @UserID
END

IF(@ConfirmGUID Is Not Null)
BEGIN
	Update sb_usrs Set ConfirmGUID = Null Where ConfirmGUID = @ConfirmGUID
END
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetGallery]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetGallery] 
	(
	@SiteID int = null, 
	@GalleryID int
	)
AS
	Select * From sb_galleries Where GalleryID = @GalleryID
	
	Select * From sb_galleryimages Where GalleryID = @GalleryID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveGallery]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveGallery] 
	(
	@SiteID int = null, 
	@GalleryID	int = -1,
	@Name	varchar(50),
	@ThumbWidth int = 50,
	@ThumbHeight int = 50,
	@ColumnCount int = 5
	)
AS
IF(@GalleryID = -1)
BEGIN
	Insert Into sb_galleries ([Name], SiteID) Values (@Name, @SiteID)
	Select @GalleryID = Scope_Identity()
END

Update sb_galleries Set [Name] = @Name, ThumbWidth = @ThumbWidth, ThumbHeight = @ThumbHeight, ColumnCount = @ColumnCount Where GalleryID = @GalleryID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetGalleries]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetGalleries] 
(
@SiteID int = null
)
AS
	Select * From sb_galleries where (SiteID Is Null Or SiteID = @SiteID)
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_DeleteUserExtProp]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_DeleteUserExtProp] 
	(
	@SiteID int = null, 
	@UserID Int,
	@Name VarChar(50)
	)
AS
	Delete From sb_users_ext Where UserID = @UserID And [Name] = @Name
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetUserExtProp]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetUserExtProp] 
	
	(
	@SiteID int = null, 
	@UserID int,
	@Name varchar(50)
	)
	
AS
	Declare @Value varchar(1000)
	Select @Value = [Value] From sb_users_ext Where UserID = @UserID And [Name] = @Name
	
	if(@Value Is Null)
		Set @Value = ''
		
	Select @Value
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveLink]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveLink] 
	(
	@SiteID int = null, 
	@LinkID Int = null OUTPUT,
	@Title varchar(255),
	@URL varchar(512) = null,
	@PostID int = null,
	@Group varchar(50) = null,
	@Order int = null,
	@RoleID int = null
	)
AS
	if(@LinkID Is Null)
	begin
		Insert Into sb_links (Title, SiteID) Values (@Title, @SiteID)
		Select @LinkID = Scope_Identity()
	end
	
	Update sb_links Set Title = @Title, URL = @URL, PostID = @PostID, [Group] = @Group, [Order] = @Order, RoleID = @RoleID Where LinkID = @LinkID
	
	RETURN @LinkID
GO
/****** Object:  StoredProcedure [dbo].[sb_DeleteLink]    Script Date: 10/20/2007 12:22:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_DeleteLink] 
	(
	@SiteID int = null, 
	@LinkID Int
	)
AS
	Delete From sb_links where LinkID = @LinkID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetLink]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetLink] 
	(
	@SiteID int = null, 
	@LinkID Int
	)
AS
	Select * From sb_links where LinkID = @LinkID
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_GetLinks]    Script Date: 10/20/2007 12:22:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_GetLinks] 
	(
	@SiteID int = null, 
	@Group varchar(50) = null
	)
AS
	Select * From sb_links where (@Group Is Null or [Group] = @Group)  And (SiteID Is Null Or SiteID = @SiteID) Order By [Order], Title
	RETURN
GO
/****** Object:  StoredProcedure [dbo].[sb_SavePost]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SavePost] 
	(
		@SiteID int = null, 
		@PostID Int Output,
		@AuthorID Int,
		@Title VarChar(50),
		@Preview VarChar(500),
		@Body VarChar(5000),
		@ReferenceURL VarChar(1024),
		@ReferenceTitle VarChar(50),
		@FileName VarChar(50) = null,
		@FileDescription VarChar(300) = null,
		@FileFileName VarChar(255) = null,
		@FileData Image = null,
		@FileSize decimal = null,
		@FileContentType VarChar(255) = null,
		@RemoveFile bit,
		@Publish bit = 1,
		@Comments bit = 1,
		@Details bit = 1,
		@GalleryID int = null,
		@Pinned bit = 0,
		@ShowTeaser bit = 1
	)
AS

IF(@PostID = -1)
BEGIN
	Insert Into sb_posts (Title, EntryDate, AuthorID, SiteID) Values (@Title, GetDate(), @AuthorID, @SiteID)
	Select @PostID = Scope_Identity()
END


IF(@PostID > 0)
BEGIN
	Delete From sb_postcategories Where PostID = @PostID
	
	Update sb_posts Set Title = @Title, Body = @Body, PreviewText = @Preview, ReferenceURl = @ReferenceURL, 
		ReferenceURLTitle = @ReferenceTitle, Publish = @Publish, GalleryID = @GalleryID, Comments = @Comments, Details = @Details, ShowTeaser = @ShowTeaser, Pinned = @Pinned Where PostID = @PostID
	
	Declare @FileID Int
	
	IF(@FileName Is Not Null And @RemoveFile = 0)
	BEGIN		
		Select @FileID = FileAttachmentID From sb_posts Where PostID = @PostID
				
		exec @FileID = dbo.sb_SaveAttachment @FileID, @FileName, @FileDescription, @FileFileName, @FileData, @FileSize, @FileContentType, "Attachments"
			
		Update sb_posts Set FileAttachmentID = @FileID Where PostID = @PostID
	END
	
	IF(@RemoveFile = 1)
	BEGIN
		Select @FileID = FileAttachmentID From sb_posts Where PostID = @PostID
		Update sb_posts Set FileAttachmentID = NULL Where PostID = @PostID		
		If(@FileID Is Not Null)
			exec sb_DeleteAttachment @FileID
	END
END

Select @PostID
GO
/****** Object:  StoredProcedure [dbo].[sb_SaveUserExtProp]    Script Date: 10/20/2007 12:22:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[sb_SaveUserExtProp] 
	(
	@SiteID int = null, 
	@UserID Int,
	@Name VarChar(50),
	@Value VarChar(1000) = null
	)
AS	
	exec sb_DeleteUserExtProp @UserID, @Name, @SiteID
	if(@Value is not null)
		Insert Into sb_users_ext (UserID, [Name], [Value], SiteID)
			Values (@UserID, @Name, @Value, @SiteID)
	RETURN
GO
