using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_EditFile : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		if (Request["FileID"] != null && Convert.ToInt32(Request["FileID"]) > -1)
			FileID.Value = Request["FileID"];

		if (!this.IsPostBack && FileID.Value != "")
		{
			int fileId = Convert.ToInt32(FileID.Value);

			if (fileId > 0)
			{
				DataLayer dl = new DataLayer();
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, fileId));
				DataTable dt = dl.GetDataTable("sb_GetFile", spl);
				if(dt != null && dt.Rows.Count > 0)
				{
					DataRow dr = dt.Rows[0];
					FileTitle.Text = dr["Name"].ToString();
					FileDesc.Text = dr["Description"].ToString();
					Folder.Text = dr["Folder"].ToString();
				}
			}
		}
    }
	protected void SaveButton_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		if(FileID.Value != "")
			spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, Convert.ToInt32(FileID.Value)));
		spl.Add(dl.CreateParam("@FileName", SqlDbType.VarChar, FileTitle.Text));
		spl.Add(dl.CreateParam("@FileDescription", SqlDbType.VarChar, FileDesc.Text));
		spl.Add(dl.CreateParam("@Folder", SqlDbType.VarChar, Folder.Text));
		if (FileUpload.FileName != "")
		{
			spl.Add(dl.CreateParam("@FileFileName", SqlDbType.VarChar, FileUpload.FileName));
			spl.Add(dl.CreateParam("@FileData", SqlDbType.Image, FileUpload.FileBytes));
			spl.Add(dl.CreateParam("@FileSize", SqlDbType.Decimal, FileUpload.PostedFile.ContentLength));
			spl.Add(dl.CreateParam("@FileContentType", SqlDbType.VarChar, FileUpload.PostedFile.ContentType));
		}
		dl.ExecuteScalar("sb_SaveAttachment", spl);
		Response.Redirect("~/Admin/ManageFiles.aspx");
	}
}
