using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_EditImage : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		if (Request["FileID"] != null && Convert.ToInt32(Request["FileID"]) > -1)
			FileID.Value = Request["FileID"];

        if (!this.IsPostBack)
        {
            DataLayer dl = new DataLayer();
            DataTable gdt = dl.GetDataTable("sb_GetGalleries");
            GalleryList.DataSource = gdt;
            if (gdt == null || gdt.Rows.Count < 1)
                Response.Redirect("~/Admin/ManageGalleries.aspx");
            GalleryList.DataTextField = "Name";
            GalleryList.DataValueField = "GalleryID";
            GalleryList.DataBind();
            GalleryList.Items.Insert(0, new ListItem("", ""));
        }

		if (!this.IsPostBack && FileID.Value != "")
		{
			int fileId = Convert.ToInt32(FileID.Value);

			if (fileId > 0)
			{
				DataLayer dl = new DataLayer();
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, fileId));
				DataTable dt = dl.GetDataTable("sb_GetGalleryImage", spl);
				if(dt != null && dt.Rows.Count > 0)
				{
					DataRow dr = dt.Rows[0];
					FileTitle.Text = dr["Name"].ToString();
					FileDesc.Text = dr["Description"].ToString();
					GalleryList.SelectedValue = dr["GallerID"].ToString();
				}
			}
		}
    }
	protected void SaveButton_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		spl.Add(dl.CreateParam("@FileName", SqlDbType.VarChar, FileTitle.Text));
		spl.Add(dl.CreateParam("@FileDescription", SqlDbType.VarChar, FileDesc.Text));
        spl.Add(dl.CreateParam("@GalleryID", SqlDbType.Int, Convert.ToInt32(GalleryList.SelectedValue)));
		if (FileUpload.FileName != "")
		{
            SqlParameterList gspl = new SqlParameterList();
            gspl.Add(dl.CreateParam("@GalleryID", SqlDbType.Int, Convert.ToInt32(GalleryList.SelectedValue)));
            DataTable gDt = dl.GetDataTable("sb_GetGallery", gspl);

            int imgWidth = 50;
            int imgHeight = 50;

            if (gDt != null && gDt.Rows.Count > 0)
            {
                imgWidth = Convert.ToInt32(gDt.Rows[0]["ThumbWidth"]);
                imgHeight = Convert.ToInt32(gDt.Rows[0]["ThumbHeight"]);
            }

            System.Drawing.Image img = byteArrayToImage(FileUpload.FileBytes);

            if (imgWidth == 0 && imgHeight == 0) imgHeight = 50;
            if (imgWidth != 0 && imgHeight == 0)
            {
                imgHeight = Convert.ToInt32((imgWidth / (double)img.Width) * img.Height);
            }
            else if (imgHeight != 0 && imgWidth == 0)
            {
                imgWidth = Convert.ToInt32((imgHeight / (double)img.Height) * img.Width);
            }

            System.Drawing.Bitmap bmp = new System.Drawing.Bitmap(imgWidth, imgHeight, img.PixelFormat);
            System.Drawing.Graphics gphx = System.Drawing.Graphics.FromImage(bmp);

            gphx.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            gphx.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
            gphx.DrawImage(img, 0, 0, bmp.Width, bmp.Height);            
            byte[] thumbBytes = imageToByteArray(bmp);

			spl.Add(dl.CreateParam("@FileFileName", SqlDbType.VarChar, FileUpload.FileName));
			spl.Add(dl.CreateParam("@FileData", SqlDbType.Image, FileUpload.FileBytes));
			spl.Add(dl.CreateParam("@FileSize", SqlDbType.Decimal, FileUpload.PostedFile.ContentLength));
			spl.Add(dl.CreateParam("@FileContentType", SqlDbType.VarChar, FileUpload.PostedFile.ContentType));
            spl.Add(dl.CreateParam("@ThumbData", SqlDbType.Image, thumbBytes));
            spl.Add(dl.CreateParam("@ThumbSize", SqlDbType.Decimal, thumbBytes.LongLength));
		}
		dl.ExecuteScalar("sb_SaveGalleryImage", spl);
		Response.Redirect("~/Admin/ManageFiles.aspx");
	}

    //got this from http://www.codeproject.com/useritems/ImageConverter.asp
    private System.Drawing.Image byteArrayToImage(byte[] byteArrayIn)
    {
        System.IO.MemoryStream ms = new System.IO.MemoryStream(byteArrayIn);
        System.Drawing.Image returnImage = System.Drawing.Image.FromStream(ms);
        return returnImage;
    }

    private byte[] imageToByteArray(System.Drawing.Image imageIn)
    {
        System.IO.MemoryStream ms = new System.IO.MemoryStream();
        imageIn.Save(ms, System.Drawing.Imaging.ImageFormat.Jpeg);
        return ms.ToArray();
    }
}
