using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Data;
using System.Data.SqlClient;

public partial class Admin_EditPost : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		Literal styleLt = new Literal();
		styleLt.Text = "<link REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"styles.css?12\">";
		this.Header.Controls.Add(styleLt);

		if (Request["ArticleID"] != null && Convert.ToInt32(Request["ArticleID"]) > -1)
			PostID.Value = Request["ArticleID"];

		if (!this.IsPostBack)
		{
			DataLayer dl = new DataLayer();
			DataTable dt = dl.GetDataTable("sb_GetCategories");
			CategoryList.DataSource = dt;
			CategoryList.DataTextField = "Category";
			CategoryList.DataValueField = "CategoryID";
			CategoryList.DataBind();

            DataTable gdt = dl.GetDataTable("sb_GetGalleries");
            GalleryList.DataSource = gdt;
            GalleryList.DataTextField = "Name";
            GalleryList.DataValueField = "GalleryID";
            GalleryList.DataBind();
            GalleryList.Items.Insert(0, new ListItem("", ""));


			if (PostID.Value != "")
			{
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@PostID", SqlDbType.Int, Convert.ToInt32(PostID.Value)));
				DataSet pds = dl.GetDataSet("sb_GetPost", spl);
				DataTable pdt = pds.Tables[0];
				if (pdt != null && pdt.Rows.Count > 0)
				{
					Title.Text = pdt.Rows[0]["Title"].ToString();
					Teaser.Text = pdt.Rows[0]["PreviewText"].ToString();
					Body.Text = pdt.Rows[0]["Body"].ToString();
					RefURL.Text = pdt.Rows[0]["ReferenceURL"].ToString();
					Publish.Checked = (pdt.Rows[0]["Publish"] == DBNull.Value ? false : Convert.ToBoolean(pdt.Rows[0]["Publish"]));
                    Details.Checked = (pdt.Rows[0]["Details"] == DBNull.Value ? true : Convert.ToBoolean(pdt.Rows[0]["Details"]));
                    Comments.Checked = (pdt.Rows[0]["Comments"] == DBNull.Value ? true : Convert.ToBoolean(pdt.Rows[0]["Comments"]));
					Pinned.Checked = (pdt.Rows[0]["Pinned"] == DBNull.Value ? false : Convert.ToBoolean(pdt.Rows[0]["Pinned"]));
					ShowTeaser.Checked = (pdt.Rows[0]["ShowTeaser"] == DBNull.Value ? true : Convert.ToBoolean(pdt.Rows[0]["ShowTeaser"]));
					RefTitle.Text = pdt.Rows[0]["ReferenceURLTitle"].ToString();
                    if (pdt.Rows[0]["GalleryID"] != DBNull.Value)
                        GalleryList.SelectedValue = pdt.Rows[0]["GalleryID"].ToString();
					AttachFile.Checked = (pdt.Rows[0]["FileAttachmentID"] != DBNull.Value);
					AttachFileDiv.Visible = AttachFile.Checked;
					if (pdt.Rows[0]["FileAttachmentID"] != DBNull.Value)
					{
						spl = new SqlParameterList();
						spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, (int)pdt.Rows[0]["FileAttachmentID"]));
						DataTable fdt = dl.GetDataTable("sb_GetFile", spl);
						if (fdt != null && fdt.Rows.Count > 0)
						{
							FileTitle.Text = fdt.Rows[0]["Name"].ToString();
							FileDesc.Text = fdt.Rows[0]["Description"].ToString();
						}
					}
				}

				DataTable cdt = pds.Tables[1];
				if (cdt != null && cdt.Rows.Count > 0)
				{
					foreach (DataRow dr in cdt.Rows)
					{
						foreach (ListItem li in CategoryList.Items)
						{
							//this code and the stored proc needs to be 
							//changed to compare the 
							//integer id value of the category
							if (li.Text.ToLower() == dr["Category"].ToString().ToLower())
							{
								li.Selected = true;
								break;
							}
						}
					}
				}
			}
		}
    }

	protected void SaveButton_Click(object sender, EventArgs e)
	{
		int postId = Save();
		Response.Redirect("EditPost.aspx?ArticleID=" + postId.ToString());
	}

	protected void AttachFile_CheckedChanged(object sender, EventArgs e)
	{
		if (AttachFile.Checked)
		{
			AttachFileDiv.Visible = true;
		}
		else
		{
			AttachFileDiv.Visible = false;
		}
	}
	protected void SaveViewButton_Click(object sender, EventArgs e)
	{
		int postId = Save();
		Response.Redirect("~/Article.aspx?ArticleID=" + postId.ToString());
	}

	private int Save()
	{
		int postId = -1;

		if (PostID.Value != "")
			postId = Convert.ToInt32(PostID.Value);

		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();

		SqlParameter postIDParam = dl.CreateParam("@PostID", SqlDbType.Int, postId);
		postIDParam.Direction = ParameterDirection.InputOutput;
		spl.Add(postIDParam);
		spl.Add(dl.CreateParam("@AuthorID", SqlDbType.Int, Convert.ToInt32(Session["UserID"])));
		spl.Add(dl.CreateParam("@Title", SqlDbType.VarChar, Title.Text));
		spl.Add(dl.CreateParam("@Publish", SqlDbType.Bit, Publish.Checked));
        spl.Add(dl.CreateParam("@Comments", SqlDbType.Bit, Comments.Checked));
		spl.Add(dl.CreateParam("@Pinned", SqlDbType.Bit, Pinned.Checked));
		spl.Add(dl.CreateParam("@ShowTeaser", SqlDbType.Bit, ShowTeaser.Checked));
        spl.Add(dl.CreateParam("@Details", SqlDbType.Bit, Details.Checked));
		spl.Add(dl.CreateParam("@Preview", SqlDbType.VarChar, Teaser.Text));
		spl.Add(dl.CreateParam("@Body", SqlDbType.VarChar, Body.Text));
        if(GalleryList.SelectedValue != "")
            spl.Add(dl.CreateParam("@GalleryID", SqlDbType.Int, Convert.ToInt32(GalleryList.SelectedValue)));
		spl.Add(dl.CreateParam("@ReferenceURL", SqlDbType.VarChar, RefURL.Text));
		spl.Add(dl.CreateParam("@ReferenceTitle", SqlDbType.VarChar, RefTitle.Text));
		if (AttachFile.Checked)
		{
			spl.Add(dl.CreateParam("@FileName", SqlDbType.VarChar, FileTitle.Text));
			spl.Add(dl.CreateParam("@FileDescription", SqlDbType.VarChar, FileDesc.Text));

			if (FileUpload.FileName != "")
			{
				spl.Add(dl.CreateParam("@FileFileName", SqlDbType.VarChar, FileUpload.FileName));
				spl.Add(dl.CreateParam("@FileData", SqlDbType.Image, FileUpload.FileBytes));
				spl.Add(dl.CreateParam("@FileSize", SqlDbType.Decimal, FileUpload.PostedFile.ContentLength));
				spl.Add(dl.CreateParam("@FileContentType", SqlDbType.VarChar, FileUpload.PostedFile.ContentType));
			}

			spl.Add(dl.CreateParam("@RemoveFile", SqlDbType.Bit, 0));
		}
		else
			spl.Add(dl.CreateParam("@RemoveFile", SqlDbType.Bit, 1));

		postId = Convert.ToInt32(dl.ExecuteScalar("sb_SavePost", spl));

		foreach (ListItem li in CategoryList.Items)
		{
			if (li.Selected)
			{
				spl.Clear();
				spl.Add(dl.CreateParam("@PostID", SqlDbType.Int, postId));
				spl.Add(dl.CreateParam("@CategoryID", SqlDbType.Int, Convert.ToInt32(li.Value)));
				dl.ExecuteNonQuery("sb_SavePostCategory", spl);
			}
		}

		return postId;
	}
}
