using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_EditUser : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request["UserID"] != null && Convert.ToInt32(Request["UserID"]) > -1)
            UserID.Value = Request["UserID"];
        else
            UserID.Value = "";

        DataLayer dl = new DataLayer();
        DataTable dt = null;

        if (!this.IsPostBack)
        {           
            dt = dl.GetDataTable("sb_GetRoles");
            RoleList.DataSource = dt;
            RoleList.DataTextField = "RoleName";
            RoleList.DataValueField = "RoleID";
            RoleList.DataBind();
        }

        if (!this.IsPostBack && UserID.Value != "")
        {
            SqlParameterList spl = new SqlParameterList();
            spl.Add(dl.CreateParam("@UserID", SqlDbType.Int, Convert.ToInt32(UserID.Value)));
            DataSet ds = dl.GetDataSet("sb_GetUser", spl);
            dt = ds.Tables[0];
            if (dt != null && dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];
                FullName.Text = dr["AuthorName"].ToString();
                EmailAddress.Text = dr["AuthorEmail"].ToString();
                Username.Text = dr["Username"].ToString();
                Username.Enabled = false;
                Homepage.Text = dr["AuthorURL"].ToString();
				if (dr["SiteID"] == DBNull.Value)
					ServerAccount.Checked = true;
				else
					ServerAccount.Checked = false;
                if (dr["Enabled"] != DBNull.Value)
                    Enabled.Checked = Convert.ToBoolean(dr["Enabled"]);
            }

            DataTable rdt = ds.Tables[1];

            if (rdt != null && rdt.Rows.Count > 0)
            {
                foreach (DataRow dr in rdt.Rows)
                {
                    foreach (ListItem li in RoleList.Items)
                    {
                        if (li.Text.ToLower() == dr["RoleName"].ToString().ToLower())
                        {
                            li.Selected = true;
                            break;
                        }
                    }
                }
            }

			DataTable extdt = ds.Tables[2];

			if (extdt != null && extdt.Rows.Count > 0)
			{
				ExtProps.Visible = true;
				PropsGrid.DataSource = extdt;
				PropsGrid.DataBind();
			}

        }
        else
        {
            Username.Enabled = true;
        }
    }
    protected void SaveButton_Click(object sender, EventArgs e)
    {
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
        
        spl.Add(dl.CreateParam("@UserName", SqlDbType.VarChar, Username.Text));
        spl.Add(dl.CreateParam("@AuthorEmail", SqlDbType.VarChar, EmailAddress.Text));

        int userCount = (int) dl.ExecuteScalar("sb_CheckUser", spl);
        if (userCount < 1 || UserID.Value != "")
        {
            Crypto crypt = new Crypto();
            spl = new SqlParameterList();
            spl.Add(dl.CreateParam("@UserName", SqlDbType.VarChar, Username.Text));
            spl.Add(dl.CreateParam("@AuthorEmail", SqlDbType.VarChar, EmailAddress.Text));
            if (UserID.Value != "")
                spl.Add(dl.CreateParam("@UserID", SqlDbType.Int, Convert.ToInt32(UserID.Value)));
            if (Password.Text != "")
                spl.Add(dl.CreateParam("@Password", SqlDbType.VarChar, crypt.Encrypt(Username.Text, Password.Text)));
            spl.Add(dl.CreateParam("@AuthorName", SqlDbType.VarChar, FullName.Text));
            spl.Add(dl.CreateParam("@AuthorURL", SqlDbType.VarChar, Homepage.Text));
            spl.Add(dl.CreateParam("@Enabled", SqlDbType.Bit, Enabled.Checked));
			if(ServerAccount.Checked)
				spl.Add(dl.CreateParam("@SiteID", SqlDbType.Int, DBNull.Value));
            int userId = Convert.ToInt32(dl.ExecuteScalar("sb_SaveUser", spl));

            foreach (ListItem li in RoleList.Items)
            {
                if (li.Selected)
                {
                    spl.Clear();
                    spl.Add(dl.CreateParam("@UserID", SqlDbType.Int, userId));
                    spl.Add(dl.CreateParam("@RoleID", SqlDbType.Int, Convert.ToInt32(li.Value)));
                    dl.ExecuteNonQuery("sb_SaveUserRole", spl);
                }
            }
            Response.Redirect("ManageUsers.aspx");
        }
        else
        {
            AlreadyExistDiv.Visible = true;
        }        
    }
	protected void PropGrid_RowDataBound(object sender, GridViewRowEventArgs e)
	{
		if (e.Row.DataItem != null)
		{
			DataRow dr = ((DataRowView)e.Row.DataItem).Row;
			((TextBox)e.Row.FindControl("PropValue")).Text = dr["Value"].ToString();
		}
	}
	protected void PropGrid_RowCommand(object sender, GridViewCommandEventArgs e)
	{
		switch (e.CommandName.ToLower())
		{
			case "save":
				string newVal = ((TextBox)PropsGrid.Rows[Convert.ToInt32(e.CommandArgument)].FindControl("PropValue")).Text;
				DataKey data = PropsGrid.DataKeys[Convert.ToInt32(e.CommandArgument)];
				string setName = data.Value.ToString();
				DataLayer dl = new DataLayer();
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@UserID", SqlDbType.Int, Convert.ToInt32(UserID.Value)));
				spl.Add(dl.CreateParam("@Name", SqlDbType.VarChar, setName));
				if(newVal.Length > 0)
					spl.Add(dl.CreateParam("@Value", SqlDbType.VarChar, newVal));
				dl.ExecuteNonQuery("sb_SaveUserExtProp", spl);
				break;
		}
	}
}
