using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_ManageFiles : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		if (!this.IsPostBack)
		{
			DataLayer dl = new DataLayer();
			FilesGrid.DataSource = dl.GetDataTable("sb_GetAttachments");
			FilesGrid.DataBind();
		}
    }

	protected void FilesGrid_RowDeleting(object sender, GridViewDeleteEventArgs e)
	{
		e.Cancel = false;
	}
	protected void FilesGrid_RowCommand(object sender, GridViewCommandEventArgs e)
	{
		DataKey data = FilesGrid.DataKeys[Convert.ToInt32(e.CommandArgument)];
		int fileId = (int)data.Value;

		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();

		switch (e.CommandName.ToLower())
		{
			case "delete":
				spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, fileId));
				dl.ExecuteNonQuery("sb_DeleteAttachment", spl);
				break;
			case "publish":
				spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, fileId));
				dl.ExecuteNonQuery("sb_PublishAttachment", spl);
				break;
			case "unpublish":
				spl.Add(dl.CreateParam("@FileID", SqlDbType.Int, fileId));
				dl.ExecuteNonQuery("sb_UnpublishAttachment", spl);
				break;
			case "download":
				Response.Redirect("~/GetFile.aspx?FileID=" + fileId.ToString());
				break;
		}

		FilesGrid.DataSource = dl.GetDataTable("sb_GetAttachments");
		FilesGrid.DataBind();
	}
	protected void FilesGrid_RowDataBound(object sender, GridViewRowEventArgs e)
	{
		if (e.Row.DataItem != null)
		{
			DataRow dr = ((DataRowView)e.Row.DataItem).Row;
			if (dr["DownloadID"] == DBNull.Value)
			{
				e.Row.Cells[2].Visible = false;
				e.Row.Cells[1].Visible = true;
			}
			else
			{
				e.Row.Cells[2].Visible = true;
				e.Row.Cells[1].Visible = false;
			}

			if (dr["PostID"] != DBNull.Value)
				e.Row.Cells[3].Controls.Clear();
			else
				e.Row.Cells[10].Controls.Clear();


		}
		else
			e.Row.Cells[1].Visible = false;
	}

	protected void AddFile_Click(object sender, EventArgs e)
	{
		Response.Redirect("~/Admin/EditFile.aspx");
	}
	protected void AddImage_Click(object sender, EventArgs e)
	{
		Response.Redirect("~/Admin/EditImage.aspx");
	}
}
