using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_ManageGalleries : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		DataLayer dl = new DataLayer();
		Galleries.DataSource = dl.GetDataTable("sb_GetGalleries");
        Galleries.DataBind();

		if (Request["GalleryID"] != null && !this.IsPostBack)
		{
			if (Request["Delete"] != null)
			{
				Response.Redirect("ManageGalleries.aspx");
			}
			else
			{
				GalleryID.Value = Request["GalleryID"];
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@GalleryID", SqlDbType.Int, Convert.ToInt32(Request["GalleryID"])));
				DataTable dt = dl.GetDataTable("sb_GetGallery", spl);
				Name.Text = dt.Rows[0]["Name"].ToString();
                ThumbHeight.Text = dt.Rows[0]["ThumbHeight"].ToString();
                ThumbWidth.Text = dt.Rows[0]["ThumbWidth"].ToString();
                Columns.Text = dt.Rows[0]["ColumnCount"].ToString();
			}
		}
    }
	protected void SaveGallery_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		if (GalleryID.Value != "")
			spl.Add(dl.CreateParam("@GalleryID", SqlDbType.Int, Convert.ToInt32(GalleryID.Value)));
		spl.Add(dl.CreateParam("@Name", SqlDbType.VarChar, Name.Text));
        if(ThumbWidth.Text != "") spl.Add(dl.CreateParam("@ThumbWidth", SqlDbType.Int, Convert.ToInt32(ThumbWidth.Text)));
        if(ThumbHeight.Text != "") spl.Add(dl.CreateParam("@ThumbHeight", SqlDbType.Int, Convert.ToInt32(ThumbHeight.Text)));
        if(Columns.Text != "") spl.Add(dl.CreateParam("@ColumnCount", SqlDbType.Int, Convert.ToInt32(Columns.Text)));
		dl.ExecuteNonQuery("sb_SaveGallery", spl);
		Response.Redirect("ManageGalleries.aspx");
	}
	protected void Cancel_Click(object sender, EventArgs e)
	{
		Response.Redirect("ManageGalleries.aspx");
	}
	protected void AddImage_Click(object sender, EventArgs e)
	{
		Response.Redirect("~/Admin/EditImage.aspx");
	}
}
