using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_ManageLinks : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		DataLayer dl = new DataLayer();
		Links.DataSource = dl.GetDataTable("sb_GetLinks");
		Links.DataBind();

		DataTable dt;

		if (!this.IsPostBack)
		{
			dt = dl.GetDataTable("sb_GetRoles");
			RoleList.DataSource = dt;
			RoleList.DataTextField = "RoleName";
			RoleList.DataValueField = "RoleID";
			RoleList.DataBind();
			RoleList.Items.Insert(0, new ListItem("", ""));

			dt = dl.GetDataTable("sb_GetPostTitles");
			ArticleList.DataSource = dt;
			ArticleList.DataTextField = "Title";
			ArticleList.DataValueField = "PostID";
			ArticleList.DataBind();
			ArticleList.Items.Insert(0, new ListItem("", ""));
		}

		if (Request["LinkID"] != null && !this.IsPostBack)
		{

			if (Request["Delete"] != null)
			{
				LinkID.Value = Request["LinkID"];
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@LinkID", SqlDbType.Int, Convert.ToInt32(Request["LinkID"])));
				dl.GetDataTable("sb_DeleteLink", spl);
				Response.Redirect("ManageLinks.aspx");
			}
			else
			{				
				LinkID.Value = Request["LinkID"];
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@LinkID", SqlDbType.Int, Convert.ToInt32(Request["LinkID"])));
				dt = dl.GetDataTable("sb_GetLink", spl);
				LinkTitle.Text = dt.Rows[0]["Title"].ToString();
				if (dt.Rows[0]["PostID"] != DBNull.Value)
					ArticleList.SelectedValue = dt.Rows[0]["PostID"].ToString();
				if (dt.Rows[0]["RoleID"] != DBNull.Value)
					RoleList.SelectedValue = dt.Rows[0]["RoleID"].ToString();
				URL.Text = dt.Rows[0]["URL"].ToString();
				Group.Text = dt.Rows[0]["Group"].ToString();
				Order.Text = dt.Rows[0]["Order"].ToString();
			}
		}
    }
	protected void SaveLink_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		if (LinkID.Value != "")
			spl.Add(dl.CreateParam("@LinkID", SqlDbType.Int, Convert.ToInt32(LinkID.Value)));
		spl.Add(dl.CreateParam("@Title", SqlDbType.VarChar, LinkTitle.Text));
		spl.Add(dl.CreateParam("@URL", SqlDbType.VarChar, URL.Text));
		spl.Add(dl.CreateParam("@Group", SqlDbType.VarChar, Group.Text));
		if(Order.Text != "")
			spl.Add(dl.CreateParam("@Order", SqlDbType.Int, Convert.ToInt16(Order.Text)));
		if(RoleList.SelectedIndex > 0)
			spl.Add(dl.CreateParam("@RoleID", SqlDbType.Int, Convert.ToInt32(RoleList.SelectedValue)));
		if (ArticleList.SelectedIndex > 0)
			spl.Add(dl.CreateParam("@PostID", SqlDbType.Int, Convert.ToInt32(ArticleList.SelectedValue)));
		dl.ExecuteNonQuery("sb_SaveLink", spl);
		Response.Redirect("ManageLinks.aspx");
	}
	protected void Cancel_Click(object sender, EventArgs e)
	{
		Response.Redirect("ManageLinks.aspx");
	}
}
