using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_ManageRoles : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		DataLayer dl = new DataLayer();
		Roles.DataSource = dl.GetDataTable("sb_GetRoles");
		Roles.DataBind();

		if (Request["RoleID"] != null && !this.IsPostBack)
		{
			if (Request["Delete"] != null)
			{
				Response.Redirect("ManageRoles.aspx");
			}
			else
			{
				RoleID.Value = Request["RoleID"];
				SqlParameterList spl = new SqlParameterList();
				spl.Add(dl.CreateParam("@RoleID", SqlDbType.Int, Convert.ToInt32(Request["RoleID"])));
				DataTable dt = dl.GetDataTable("sb_GetRole", spl);
				Role.Text = dt.Rows[0]["RoleName"].ToString();
				if (dt.Rows[0]["SiteID"] == DBNull.Value)
					ServerRole.Checked = true;
				else
					ServerRole.Checked = false;
			}
		}
    }
	protected void SaveRole_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		if (RoleID.Value != "")
			spl.Add(dl.CreateParam("@RoleID", SqlDbType.Int, Convert.ToInt32(RoleID.Value)));
		spl.Add(dl.CreateParam("@RoleName", SqlDbType.VarChar, Role.Text));
		if (ServerRole.Checked)
			spl.Add(dl.CreateParam("@SiteID", SqlDbType.Int, DBNull.Value));
		dl.ExecuteNonQuery("sb_SaveRole", spl);
		Response.Redirect("ManageRoles.aspx");
	}
	protected void Cancel_Click(object sender, EventArgs e)
	{
		Response.Redirect("ManageRoles.aspx");
	}
}
