using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Summary description for Settings
/// </summary>
public static class Settings
{
	public static int SiteID
	{
		get
		{
			if (HttpContext.Current.Session["sbs_SiteID"] == null)
				return -1;
			else
				return Convert.ToInt16(HttpContext.Current.Session["sbs_SiteID"]);
		}
	}

    public static string GetSetting(string SettingName)
    {
        return GetSetting(SettingName, "", true);
    }

	public static string GetSetting(string SettingName, bool SaveValue)
	{
		return GetSetting(SettingName, "", SaveValue);
	}

    public static string GetSetting(string SettingName, string DefaultValue)
    {
        return GetSetting(SettingName, DefaultValue, true);
    }

	public static string GetSetting(string SettingName, string DefaultValue, bool SaveValue)
	{

		if (HttpContext.Current.Session["sbs_" + SettingName.Replace(" ", "")] == null)
		{
			DataLayer dl = new DataLayer();
			SqlParameterList spl = new SqlParameterList();
			spl.Add(dl.CreateParam("@SettingName", SqlDbType.VarChar, SettingName));
			spl.Add(dl.CreateParam("@DefaultValue", SqlDbType.VarChar, DefaultValue));
            spl.Add(dl.CreateParam("@SaveValue", SqlDbType.Bit, SaveValue));
			HttpContext.Current.Session["sbs_" + SettingName.Replace(" ", "")] = dl.ExecuteScalar("sb_GetSetting", spl).ToString();
		}

		return HttpContext.Current.Session["sbs_" + SettingName.Replace(" ", "")].ToString();
	}
}
