using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Archive : System.Web.UI.Page
{
	private string[] months = new string[12] { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };

    protected void Page_Load(object sender, EventArgs e)
    {
		if (Request["Month"] == null || Request["Year"] == null)
			Response.Redirect("~/Default.aspx");
		
		//if(!this.IsPostBack)
			BindData();
    }

	private void BindData()
	{
		MonthLabel.Text = GetMonthTitle(Convert.ToInt32(Request["Month"]), Convert.ToInt32(Request["Year"]));
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		spl.Add(dl.CreateParam("@Month", SqlDbType.Int, Convert.ToInt32(Request["Month"])));
		spl.Add(dl.CreateParam("@Year", SqlDbType.Int, Convert.ToInt32(Request["Year"])));
		DataTable dt = dl.GetDataTable("sb_GetMonthlyTeasers", spl);
		PostTeasers.DataSource = dt;
		PostTeasers.DataBind();
	}

	private string GetMonthTitle(int Month, int Year)
	{
		return months[Month - 1] + " " + Year;
	}
}
