<%@ Page language="c#" MasterPageFile="~/Default.master" Inherits="Article" CodeFile="Article.aspx.cs" %>

<%@ Register Src="Controls/SimpleGallery.ascx" TagName="SimpleGallery" TagPrefix="uc1" %>
<%@ MasterType VirtualPath="~/Default.master" %>

<asp:Content ID="PageContent" ContentPlaceHolderID="Content" Runat="Server">
		<input runat="server" type="hidden" id="PostID" />
		<div class="Post">
			<div class="PostTitle"><asp:Label ID="TitleLabel" runat="server"></asp:Label></div>
			<div class="PostBody"><asp:Label ID="BodyLabel" runat="server"></asp:Label></div>
            <div class="PostGallery" id="PostGallery" runat="server"><uc1:SimpleGallery ID="SimpleGallery1" runat="server" /></div>			
			<div class="PostReference" id="Reference" runat="server"><asp:Literal ID="RefLink" runat="server"></asp:Literal></div>			
			<div class="PostDownload" id="Download" runat="server"><asp:Literal ID="FileLink" runat="server"></asp:Literal></div>						
			<asp:Panel runat="server" id="PostDetails">
			    <div class="PostAuthor">Written by <asp:Label ID="AuthorLabel" runat="server"></asp:Label> on <asp:Label ID="EntryDate" runat="server"></asp:Label> | Comments(<asp:Label ID="CommentsCountLabel" runat="server"></asp:Label>)</div>			
    			<div class="PostCategories" id="Categories" runat="server" visible="false">Filed under <asp:Label ID="CategoriesList" runat="server"></asp:Label></div>
			</asp:Panel>
			<div class="CommentsRegion" id="Comments" runat="server">
			<asp:Repeater ID="CommentsRepeater" runat="server" OnItemDataBound="CommentsRepeater_ItemDataBound">
				<ItemTemplate>
				<div class="UserCommentRegion">
				<div class="CommentName" id="UserCommentName"><asp:Literal ID="CommentUserName" runat="server"></asp:Literal></div>				
				<div class="CommentText" id="UserCommentText"><%# DataBinder.Eval(Container.DataItem, "EntryText") %></div>
				<div class="CommentDate">Posted on <%# DataBinder.Eval(Container.DataItem, "EntryDate", "{0:D}") %></div>
				</div>
				</ItemTemplate>
			</asp:Repeater>
			<div class="UserComment" id="UserComment" runat="server" visible="true">
				<div>Name</div>
				<div><asp:TextBox ID="CommentName" runat="server"></asp:TextBox></div>
				<div>Email Address</div>
				<input type="hidden" id="AutoPost" runat="server"/>
				<div><asp:TextBox ID="CommentEmail" runat="server" ValidationGroup="Comment"></asp:TextBox>
					<asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ControlToValidate="CommentEmail"
						Display="Dynamic" ErrorMessage="A valid email address is required to post comments."
						ValidationExpression="\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*" ValidationGroup="Comment"></asp:RegularExpressionValidator>
					<asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="CommentEmail"
						Display="Dynamic" ErrorMessage="An email address is required to post comments." ValidationGroup="Comment"></asp:RequiredFieldValidator></div>
				<div>Homepage</div>
				<div><asp:TextBox ID="CommentURL" runat="server" ValidationGroup="Comment"></asp:TextBox>
					<asp:RegularExpressionValidator ID="RegularExpressionValidator2" runat="server" ControlToValidate="CommentURL"
						ErrorMessage="The URL must be in a valid format." ValidationExpression="http(s)?://([\w-]+\.)+[\w-]+(/[\w- ./?%&=]*)?" ValidationGroup="Comment"></asp:RegularExpressionValidator></div>
				<div>Comments</div>
				<div><asp:TextBox ID="Comment" MaxLength="500" Height="50" Width="500" runat="server" TextMode="MultiLine"></asp:TextBox></div>
				<div>&nbsp;</div>
				<div><asp:Button ID="SaveButton" runat="server" Text="Submit" OnClick="SaveButton_Click" ValidationGroup="Comment" /></div>
			</div>
			<div id="SubmitInstructions" runat="server" visible="false">
			<b>NOTICE:</b> The email address you entered will be sent an email with a validation link that must be clicked (visited) before your comment will be posted.  All unverfied comments will be deleted within 24 hours.
			</div>
			</div>
		</div>

</asp:Content>
