using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_MonthNav : System.Web.UI.UserControl
{
	private int monthCount = 0;
	private int monthsToShow = 5;
	private string[] months = new string[12] { "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" };
    protected void Page_Load(object sender, EventArgs e)
    {
		BindMonths();

		monthsToShow = Convert.ToInt32(Settings.GetSetting("MonthsToPreview", "5", true));
		monthCount = 0;
		if (monthsToShow == 0 || ShowMoreMonths)
			PreviewMoreButton.Visible = false;
    }

	private void BindMonths()
	{
		DataLayer dl = new DataLayer();
		MonthRepeater.DataSource = dl.GetDataTable("sb_GetMonthlyPostCount");
		MonthRepeater.DataBind();
	}

	private bool ShowMoreMonths
	{
		get
		{
			if (Session["ShowMoreMonths"] == null)
				return false;
			else
				return (bool)Session["ShowMoreMonths"];
		}

		set
		{
			Session["ShowMoreMonths"] = value;
		}
	}
	protected string GetMonthTitle(int Month, int Year)
	{		
		return months[Month-1] + " " + Year;
	}
	protected void MonthRepeater_ItemDataBound(object sender, RepeaterItemEventArgs e)
	{
		if(e.Item.ItemType == ListItemType.AlternatingItem || e.Item.ItemType == ListItemType.Item)
		{
			DataRow dr = ((DataRowView) e.Item.DataItem).Row;
			if (dr != null && (monthCount < monthsToShow || monthsToShow == 0 || ShowMoreMonths))
			{
				LinkButton lb = new LinkButton();
				lb.CausesValidation = false;
				lb.PostBackUrl = @"~\Archive.aspx?Month=" + dr["Month"].ToString() + "&Year=" + dr["Year"].ToString();	
				lb.Text = GetMonthTitle((int) dr["Month"], (int) dr["Year"]) + " (" + dr["PostCount"].ToString() + ")";
				lb.CssClass = "MonthNavLink";
				e.Item.Controls.Add(lb);
			}
			monthCount++;
		}
	}
	protected void PreviewMoreButton_Click(object sender, EventArgs e)
	{
		ShowMoreMonths = true;
		PreviewMoreButton.Visible = false;
		BindMonths();
	}
}
