using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Controls_SimpleNav : System.Web.UI.UserControl
{
	private string _group = "SimpleNav";

    protected void Page_Load(object sender, EventArgs e)
    {

    }

	protected override void OnPreRender(EventArgs e)
	{
		//if (!this.IsPostBack)
		{
			DataLayer dl = new DataLayer();
			SqlParameterList spl = new SqlParameterList();
			if (Group != "")
				spl.Add(dl.CreateParam("@Group", SqlDbType.VarChar, Group));
			DataTable dt = dl.GetDataTable("sb_GetLinks", spl);
			if (dt != null && dt.Rows.Count > 0)
			{
				string url = "";
				foreach (DataRow dr in dt.Rows)
				{
					if ((dr["RoleID"] != DBNull.Value && HttpContext.Current.User.Identity.IsAuthenticated) || dr["RoleID"] == DBNull.Value)
					{

						HyperLink aLink = new HyperLink();
						if (dr["PostID"] == DBNull.Value)
							url = dr["URL"].ToString();
						else
							url = "~/Article.aspx?ArticleID=" + dr["PostID"].ToString();
						aLink.CssClass = Group + "Link";
						aLink.Text = dr["Title"].ToString();
						aLink.NavigateUrl = url;

						if (dr["RoleID"] != DBNull.Value)
						{
							if (HttpContext.Current.User.Identity.IsAuthenticated)
							{
								spl = new SqlParameterList();
								spl.Add(dl.CreateParam("@RoleID", SqlDbType.Int, Convert.ToInt32(dr["RoleID"])));
								DataTable rdt = dl.GetDataTable("sb_GetRole", spl);
								string roleName = rdt.Rows[0]["RoleName"].ToString();
								if (HttpContext.Current.User.IsInRole(roleName))
									SimpleNavList.Controls.Add(aLink);
							}
						}
						else
							SimpleNavList.Controls.Add(aLink);
					}
				}
			}
		}

		base.OnPreRender(e);
	}

	public string Group
	{
		set
		{
			NavGroup.Value = value;
		}
		get
		{
			return NavGroup.Value;
		}
	}

	public string Title
	{
		set
		{
			NavTitle.Text = value;
		}
		get
		{
			return NavTitle.Text;
		}
	}
}
