using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {            
		//if (Application["AppSetup"] == null)
		{
			DataLayer dl = new DataLayer();
			DataTable dt = dl.GetDataTable("sb_GetUsers");
            if (dt == null || dt.Rows.Count == 0)
            {
                Application.Remove("AppSetup");
                FirstTimeUser.Visible = true;
            }
            else
            {
                if (Convert.ToBoolean(Settings.GetSetting("AllowRegistration", "False")))
                    RegistationNotice.Visible = true;
                Application["AppSetup"] = 1;
            }
		}
    }

	protected void LoginButton_Click(object sender, EventArgs e)
	{
        int maxIPLogin = Convert.ToInt32(Settings.GetSetting("MaxIPLoginAttempts", "0"));
        int maxLogin = Convert.ToInt32(Settings.GetSetting("MaxUserLoginAttempts", "3"));
        int currentLogin = (Session["LoginAttempt"] == null ? 0 : (int)Session["LoginAttempt"]);
        int currentIPLogin = (Application["Login" + Request.UserHostAddress] == null ? 0 : (int)Application["Login" + Request.UserHostAddress]);
        if (maxLogin > 0 && currentLogin > maxLogin)
        {
            MaxLoginDiv.Visible = true;
            return;
        }

        if (maxIPLogin > 0 && currentIPLogin > maxIPLogin)
        {
            MaxLoginDiv.Visible = true;
            return;
        }

		int userId = -1;
		string userRoles = "";
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		Crypto crypt = new Crypto();

		spl.Add(dl.CreateParam("@Username", SqlDbType.VarChar, Username.Text));
		spl.Add(dl.CreateParam("@Password", SqlDbType.VarChar, Password.Text == "admin" ? Password.Text : crypt.Encrypt(Username.Text, Password.Text)));

        if (Application["AppSetup"] == null)
        {
            userId = Convert.ToInt32(dl.ExecuteScalar("sb_SaveUser", spl));
            if (userId > 0)
            {
                SqlParameterList splRole = new SqlParameterList();
                splRole.Add(dl.CreateParam("@UserID", SqlDbType.Int, userId));
                splRole.Add(dl.CreateParam("@RoleName", SqlDbType.VarChar, "Administrator"));
                dl.ExecuteNonQuery("sb_SaveUserRole", splRole);
            }
        }

		DataSet userDs = dl.GetDataSet("sb_AuthUser", spl);
		if (userDs != null && userDs.Tables.Count > 0)
		{
			if(userDs.Tables[0] != null && userDs.Tables[0].Rows.Count > 0)
				userId = Convert.ToInt32(userDs.Tables[0].Rows[0]["UserID"]);

			if (userDs.Tables[1] != null && userDs.Tables[1].Rows.Count > 0)
			{
				for(int i=0;i< userDs.Tables[1].Rows.Count;i++)
				{
					DataRow dr = userDs.Tables[1].Rows[i];
					userRoles += (userRoles.Length > 0 ? "|" : "") + dr["RoleName"].ToString();
				}
			}
		}

        if (userId > 0)
        {
            FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(1, Username.Text, DateTime.Now, DateTime.Now.AddMinutes(Session.Timeout), false, userRoles);
            HttpCookie authCookie = new HttpCookie(FormsAuthentication.FormsCookieName, FormsAuthentication.Encrypt(ticket));
            Response.Cookies.Add(authCookie);

            Session.Add("UserID", userId.ToString());

            Session.Remove("LoginAttempt");
            Application.Remove("Login" + Request.UserHostAddress);

            if (FormsAuthentication.GetRedirectUrl(Username.Text, false) == null)
                Response.Redirect("~/Default.aspx");
            else
                Response.Redirect(FormsAuthentication.GetRedirectUrl(Username.Text, false));


        }
        else
        {
            BadLoginDiv.Visible = true;
            if (Session["LoginAttempt"] == null)
                Session.Add("LoginAttempt", 1);
            else
                Session["LoginAttempt"] = (int) Session["LoginAttempt"] + 1;

            //ip level blocking
            if (Application["Login" + Request.UserHostAddress] == null)
                Application.Add("Login" + Request.UserHostAddress, 1);
            else
                Application["Login" + Request.UserHostAddress] = (int)Application["Login" + Request.UserHostAddress] + 1;
        }
	}
}
