using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net.Mail;

public partial class Register : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Convert.ToBoolean(Settings.GetSetting("AllowRegistration", "False")))
        {
            Response.Redirect("Default.aspx");
        }

        if (Request["Confirm"] != null)
        {
            DataLayer dl = new DataLayer();
            SqlParameterList spl = new SqlParameterList();
            spl.Add(dl.CreateParam("@ConfirmGUID", SqlDbType.Char, Request["Confirm"]));
            dl.ExecuteNonQuery("sb_ConfirmUser", spl);
            Response.Redirect("Default.aspx");
        }
    }
	protected void SubmitButton_Click(object sender, EventArgs e)
	{
		DataLayer dl = new DataLayer();
		SqlParameterList spl = new SqlParameterList();
		spl.Add(dl.CreateParam("@UserName", SqlDbType.VarChar, Username.Text));
        spl.Add(dl.CreateParam("@AuthorEmail", SqlDbType.VarChar, EmailAddress.Text));

        int userCount = (int) dl.ExecuteScalar("sb_CheckUser", spl);
        if (userCount < 1)
        {
            Crypto crypt = new Crypto();
            spl = new SqlParameterList();
            spl.Add(dl.CreateParam("@UserName", SqlDbType.VarChar, Username.Text));
            spl.Add(dl.CreateParam("@AuthorEmail", SqlDbType.VarChar, EmailAddress.Text));
            spl.Add(dl.CreateParam("@Password", SqlDbType.VarChar,  crypt.Encrypt(Username.Text, Password.Text)));
            spl.Add(dl.CreateParam("@AuthorName", SqlDbType.VarChar, FullName.Text));
            spl.Add(dl.CreateParam("@AuthorURL", SqlDbType.VarChar, Homepage.Text));
            spl.Add(dl.CreateParam("@Enabled", SqlDbType.Bit, true));
            string userGuid = System.Guid.NewGuid().ToString();
            spl.Add(dl.CreateParam("@ConfirmGUID", SqlDbType.Char, userGuid));
            dl.ExecuteNonQuery("sb_SaveUser", spl);

            string mailServer = System.Configuration.ConfigurationManager.AppSettings["SMTPServer"];

            if (mailServer != null && mailServer != "")
            {
                string strTo = EmailAddress.Text;
                string strFrom = System.Configuration.ConfigurationManager.AppSettings["AdminEmailAddress"];
                string strSubject = Settings.GetSetting("SiteTitle") + " Account Confirmation";
                string user = System.Configuration.ConfigurationManager.AppSettings["SMTPServerUser"];
                string pass = System.Configuration.ConfigurationManager.AppSettings["SMTPServerPassword"];

                SmtpClient mail = new SmtpClient();
                if (user != null && user != "" && pass != null && pass != "")
                    mail.Credentials = new System.Net.NetworkCredential(user, pass);
                mail.Host = mailServer;

                try
                {
                    mail.Send(strFrom, strTo, strSubject, FullName.Text + ",\n\nTo confirm the account you created at " + Settings.GetSetting("SiteTitle") + " please click on this link (or copy and paste into your web browser):\n\n" +
                        this.Request.Url.ToString() + "?Confirm=" + userGuid + "\n\n" +
                        "The account will not be active and you will not be able to view or posted protected content until you have confirmed the account at the link above.  Thank you.");
                    UserRegDiv.Visible = false;
                    ConfirmDiv.Visible = true;
                }
                catch
                {
                    return;
                }
            }
        }
        else
        {
            AlreadyExistDiv.Visible = true;
        }
	}
}
