using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Rss : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
		DataLayer dl = new DataLayer();
		DataTable dt = dl.GetDataTable("sb_GetPostTeasers");
		DateTime lastUpdate = DateTime.Now;
		if(dt != null && dt.Rows.Count > 0)
		{
			if(dt.Rows[0]["EntryDate"] != DBNull.Value)
				lastUpdate = Convert.ToDateTime(dt.Rows[0]["EntryDate"]);
		}

		string siteURL = Request.Url.ToString().Substring(0, Request.Url.ToString().LastIndexOf('/'));
		Response.Clear();
		Response.ContentType = "application/rss+xml";
		Response.Write("<?xml version=\"1.0\"?>\n");
		Response.Write("<rss version=\"2.0\">\n");
		Response.Write("<channel>\n");
		Response.Write("<title>" + Settings.GetSetting("SiteTitle") + "</title>\n");
		Response.Write("<link>" + siteURL + "</link>");
		Response.Write("<description>" + Settings.GetSetting("SiteSubTitle") + "</description>\n");
		Response.Write("<language>" + Settings.GetSetting("SiteLanguage", "en-us") + "</language>");
		Response.Write("<pubDate>" + RFC822.GetDate(lastUpdate) + "</pubDate>");
		Response.Write("<lastBuildDate>" +  RFC822.GetDate(lastUpdate) + "</lastBuildDate>");
		Response.Write("<generator>Simple Blog .NET</generator>");
		Response.Write("<managingEditor>" + Settings.GetSetting("SiteAdminEmail") + "</managingEditor>");
		Response.Write("<webMaster>" + Settings.GetSetting("SiteAdminEmail") + "</webMaster>");

		foreach(DataRow dr in dt.Rows)
		{
			Response.Write("<item>");
			Response.Write("<title>" + dr["Title"].ToString().Replace("&","&amp;") + "</title>");
			Response.Write("<link>" + siteURL + "/Article.aspx?ArticleID=" + dr["PostID"].ToString() + "</link>");
			Response.Write("<description>" + dr["PreviewText"].ToString().Replace("&", "&amp;") + "</description>");
			Response.Write("<pubDate>" + RFC822.GetDate(Convert.ToDateTime(dr["EntryDate"])) + "</pubDate>");
			Response.Write("<guid>" + siteURL + "/Article.aspx?ArticleID=" + dr["PostID"].ToString() + "</guid>");
			Response.Write("</item>");
		}

		Response.Write("</channel>");
		Response.Write("</rss>");

    }
}
